#include <stdio.h>
#include <math.h>

main(int argc, char *argv[])
{
  int     NUM_SAMPLES;
  double *gaussian;
  double  sum;
  int     i;
  double  x_value;
  double  step_size;

  if (argc != 2) {
    printf("Usage: %s number_of_entries\n", argv[0]);
    exit(1);
  }

  NUM_SAMPLES = atoi(argv[1]);
  if (NUM_SAMPLES < 2) {
    printf("%s: number_of_entries must be > 1\n", argv[0]);
    exit(2);
  }

  gaussian = (double *) malloc(sizeof(double)*NUM_SAMPLES);
  if (!gaussian) {
    printf("%s: Can't malloc %d entries for gaussian\n",argv[0],NUM_SAMPLES);
    exit(3);
  }

  /* compute values of a standard Gaussian curve */
  sum = 0.0;
  step_size = 5.0 / (NUM_SAMPLES - 1);
  for ( i=0 ; i<NUM_SAMPLES ; i++ ) {
    x_value = -2.5 + i * step_size;
    gaussian[i] = exp(-(x_value*x_value));
    printf("%d: x = %lf Gauss[i] = %lf\n",i,x_value,gaussian[i]);
    sum += gaussian[i];
  }
    printf("Sum of gaussian is %lf\n",sum);

  /* make total weight of the filter = 1.0 */
  for ( i=0 ; i<NUM_SAMPLES ; i++ )
    gaussian[i] /= sum;

  /* output in format for declaration */
  printf("#define NUM_SAMPLES %d\n", NUM_SAMPLES);
  printf("static double GAUSSIAN[NUM_SAMPLES] = {\n");
  for ( i=1 ; i<=NUM_SAMPLES ; i++ ) {
    printf("%.14lf, ",gaussian[i-1]);
    if (i % 4 == 0) printf("\n");
  }
  printf("};\n");

}

